
/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		anWindow;
	id		basc;
	id		baux;
	id		histoGram;
	id		wrule;
	id		dataList;
	id		ruleNumber;

	id		tiDat;
	id		valBx;
	id		varText;
	id		varWindow;
	
	id		theEvolView;
	id		thePlaidView;
	id		theShEvolView;
	id		theThEvolView;

	id		evolWindow;
	id		keyWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	id		plaidWindow;
	
	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;

	id 		gridSize;
	id		aSwitch;

	id 		keepTop;
}

- copyEvolu:sender;
- copyPlEvol:sender;
- copyShEvol:sender;
- copyThEvol:sender;
- drawEvolu:sender;
- drawPlEvol:sender;
- drawShEvol:sender;
- drawThEvol:sender;
- nxmoncar: (int) l;
- printEvolu:sender;
- prob:sender;

- drawStat:sender;
- printPlain:sender;
- printStat:sender;
- printShEvol:sender;
- printThEvol:sender;

		/* for plaid diagram  */
- drawPlaid:sender;
- printPlaid:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- plot:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;

@end

/* end LCAUView.h */
