
#import "RulePanel.h"
#import "nxlcau22.h"
#import "rec.h"
#import <string.h> 
#import <time.h>
#import <ctype.h> 

extern int  co, dn;			/* connectivity, dimension */
extern int  binrule[KK][KK][KK][KK][KK];
extern char arr1[AL], arr2[AL];
extern char ascrule[KK][KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK][KK];
extern char gf2rule[13];		/*   coefficients of GF2 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern char strule[KK][SS];
extern char sarule[KK][SS];
extern char ixrule[NX][DS];

extern struct fptbl dtbl2[];
extern Inst xprg[XLEN];
extern char idef[][30];

void definerule(unsigned long int n);
int longwolftoasc(char *c);

int     allperm(char wn[RSYM][WNML], ascrular ii[], ascrular *ru);
void    asctobin();
void    asctotot();
void	asczero();
void	auxzero();
void    bintoasc();
void    chrucopy(char ii[KK][KK][KK][KK][KK],
	         char jj[KK][KK][KK][KK][KK],
		 int c);
void    clumin(char *c);
int     cyy(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
void    grantotrule();
void    granptotrule();
int     istot();
int     isstot();
void    numtobin21(int ru[KK][KK][KK], int n);
void    nutoto(int n);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(binrular *pr, binrular *br, int k);
void    putionj(int i, int j);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p1, double p2);
void    ranplacor();
void    ransolcor();
void    ranvachrul(char *c);
void    rule24();
void	sttoasc();
void    stzero();
void    tazero();
void	totoasc();
int     totonu(int i);
void    ttzero();
void    wrru(char *c, char ru[KK][KK][KK][KK][KK]);   
int     vecperm(int ii[KK], int n);
int     ycc(int i);
void    zerline();

/*  declarations for REC  */
extern int rec_c(char *z, Inst rprg, int l, struct fptbl dtbl2[]);
extern int rec2(char *z);
 

/* declarations for arithmetic combinations   */
void bincopy(binrular *rz, int rx[KK][KK][KK][KK][KK]);
void binprint(binrular rz);
void binprod(binrular *rz, binrular rx, binrular ry);
void binsum(binrular *rz, binrular rx, binrular ry);
void byntoasc();
void rever3();
void rever2();

char    xr[DS] = "12122010122120000010100010010101";
char    xp[DS] = "21221122112211221122112211221121";
char    xq[DS] = "13333333333333333333333333333332";

@implementation RulePanel

int permu[RSYM/2][KK] = {
			{0, 1},
			{1, 0}
			};

/* - - - - - - - -  R E C   L I N E   C O N F I G U R A T I O N  - - - - - */
 
- useRECLine:sender {
  [RECPanel makeKeyAndOrderFront: sender];
  [RECValue setStringValue: "*"];
 return self;
}

- runRECLine:sender; {
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) {
     [RECValue setStringValue: "T"];
     [self setAllRules: self];
     }
  else
    [RECValue setStringValue: "F"];
  return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */ 

- setDimension:sender {dn = [sender selectedRow]+1; return self;}

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=ruleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==symWindow)  nowBox=symBox;
  if (sender==toWindow)   nowBox=toBox;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- protectGenRule:sender {int i, j, k, i0, i1, i2, i3, i4;
  i=j=[sender selectedCol];
  i4=i%KK; i/=KK;
  i3=i%KK; i/=KK;
  i2=i%KK; i/=KK;
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
  k=auxrule[i0][i1][i2][i3][i4];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1][i2][i3][i4]=!k;
return self;
}

- showSymClass:sender {
char ii[RSYM][KK][KK][KK][KK][KK], wnum[RSYM][WNML]; int i, l;
  l=allperm(wnum,ii,ascrule);
  for (i=0; i<RSYM/2; i++) {
	[[symImages cellAt: i: 0] setStringValue: wnum[i]];
	[[symImages cellAt: i: 1] setStringValue: wnum[i+RSYM/2]];
	}
  [symMinimum setStringValue: wnum[l]];
return self;
}

- relatedRule:sender {
ascrular ii[RSYM]; char wnum[RSYM][WNML], c[WNML], *titl;
int l, k, j, jj[KK];
  k= 0;
  l= allperm(wnum,&ii[0],ascrule);
  titl=[[sender selectedCell] title];
        if (strcmp(titl,"keep")==0)       k=0;
   else if (strcmp(titl,"complement")==0) k=1;
   else if (strcmp(titl,"cluster")==0)    k=RSYM;
   else if (strcmp(titl,"reflected")==0)  k=2;
   else if (strcmp(titl,"least")==0)      k=l;
   else if (strcmp(titl,"both")==0)       k=3;
   else					  k=0;
printf("relatedRule: k=%d\n",k);
   if (k==RSYM) {
     clumin(c);
     longwolftoasc(c);
     [self setAllRules: self];
     return self;
     }
   chrucopy(ascrule,&ii[k],'w');
   [self setAllRules: self];
   if ([changeLine state]) {
	  l=vecperm(jj,k);
	  for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
	  if (l) {
		for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
		for (j=0; j<AL; j++) arr1[j]=arr2[j];
		 }
	}
return self;
}    

/* report Wolfram rule number or variant */
void chrucopy(ii, jj, c) 
 char ii[KK][KK][KK][KK][KK];
 char jj[KK][KK][KK][KK][KK];
 char c;    {int k, i0, i1, i2, i3, i4;

 k=0;
  switch (c) {
    case 'w':
           for (i0=0; i0<KK; i0++) 
	   for (i1=0; i1<KK; i1++)
	   for (i2=0; i2<KK; i2++) 
  	   for (i3=0; i3<KK; i3++) 
	   for (i4=0; i4<KK; i4++)
		ii[i0][i1][i2][i3][i4]=jj[i0][i1][i2][i3][i4];
      break;
    case 'y':
           for (i0=0; i0<KK; i0++) 
	   for (i1=0; i1<KK; i1++)
	   for (i2=0; i2<KK; i2++) 
  	   for (i3=0; i3<KK; i3++) 
	   for (i4=0; i4<KK; i4++)
		ii[i0][i1][i2][i3][i4]=
			ycc(jj[cyy(i0)][cyy(i1)][cyy(i2)][cyy(i3)][cyy(i4)]);
      break;
    case 'r':
           for (i0=0; i0<KK; i0++) 
	   for (i1=0; i1<KK; i1++)
	   for (i2=0; i2<KK; i2++) 
  	   for (i3=0; i3<KK; i3++) 
	   for (i4=0; i4<KK; i4++)
		ii[i0][i1][i2][i3][i4]=jj[i4][i3][i2][i1][i0];
      break;
     default: k=0; break;}
}



int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '0'; 
	case  0:  return  1;
	case  1:  return  0; 
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '0'; 
	case  0:  return  1;
	case  1:  return  0; 
	default:  return '0';}
}

void clumin(c) char *c; {
char d[WNML]; ascrular ii[RSYM]; char wnum[RSYM][WNML];
int  i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,&ii[0],ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(ascrule,&ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

int vecperm(ii,n) int ii[KK], n; {int i,k,l;
  l=!(n<2); k=(l?n-2:n);
  switch (k) {
    case 0: for (i=0; i<KK; i++) ii[i]=i; break;
    case 1: for (i=0; i<KK; i++) ii[i]=ycc(i); break;
       default : for (i=0; i<KK; i++) ii[i]=i; break;}
  return l;
}

void ptedbrul(pr,br,k) binrular *pr, *br; int k; {int i;
  for (i=0; i<DS; i++) pr->one[i]=permu[k][br->one[i]];
}

int allperm(wn,ii,ru) char wn[RSYM][WNML]; ascrular ii[], *ru; {int k, l;
  chrucopy(&ii[0],ascrule, 'w');
  chrucopy(&ii[1],ascrule, 'y');
  chrucopy(&ii[2],ascrule, 'r');
  chrucopy(&ii[3],&ii[2],   'y'); 
  for(k=0, l=0; k<RSYM; k++) {
	wrru(wn[k],&ii[k]);
	if (strlen(wn[k]) > strlen(wn[l])) continue;
	if (strlen(wn[k]) < strlen(wn[l])) { l=k; continue; }
	if (strcmp(wn[k],wn[l]) < 0) l=k;
  }
 return l;
}

/* - - - --  create the rule defined by the "symmetric rule" panel  - - - - */

- symRule:sender {
int j00, j01, j02, j10, j11, j12, j20, j21, j22;
int i0, i1, i2, i3, i4, j0, j1, r;
j00=[[s00 selectedCell] tag];
j01=[[s01 selectedCell] tag];
j02=[[s02 selectedCell] tag];
j10=[[s10 selectedCell] tag];
j11=[[s11 selectedCell] tag];
j12=[[s12 selectedCell] tag];
j20=[[s20 selectedCell] tag];
j21=[[s21 selectedCell] tag];
j22=[[s22 selectedCell] tag];
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) 
     for (i3=0; i3<KK; i3++)   for (i4=0; i4<KK; i4++) {
    j0=KK+i1-i0;
    j1=KK+i2-i1;
    r =j00+j0*(j10+j0*j20)+j1*(j01+j1*j20);
    r+=j0*j1*(j11+j0*j21+j1*j12);
    r+=j0*j0*j1*j1*j22;
    switch([[sIncr selectedCell] tag]) {
      case 0: r+=i0; break;
      case 1: r+=i1; break;
      case 2: r+=i2; break;
      case 3: r+=i3; break;
      case 4: r+=i4; break;
      case 5: r+=(KK-i0)+(KK-i1); break;
      case 6: r+=(KK-i1)+(KK-i2); break;
      case 7: r+=(KK-i2)+(KK-i3); break;
      case 8: r+=(KK-i3)+(KK-i4); break;
      case 9: r+=(KK-i4)+(KK-i0); break;
      case 10: break;
      default: break;}
    ascrule[i4][i3][i2][i1][i0]=r%KK+'0';
    }
  [self setAllRules: self];
  return self;
  }

- readTRule:sender {
  nutoto([sender intValue]);
  totoasc();
  [self setAllRules: self];
return self;}

- readWRule:sender {char *c;
   c=[sender stringValue];
   if (longwolftoasc(c)) [self setAllRules: self];
   else
     [ruleNumber setStringValue:"Invalid"]; 
 return self;
}

int longwolftoasc (char *c) {
char d[WNML], e;
int i, i0, i1, i2, l, n;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'f') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'F') n=e-'A'+10;
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    n=d[KK*KK*KK-i0*KK*KK-i1*KK-i2-1];
    ascrule[i0][i1][i2][0][0]='0'+n%KK; n/=KK;
    ascrule[i0][i1][i2][0][1]='0'+n%KK; n/=KK;
    ascrule[i0][i1][i2][1][0]='0'+n%KK; n/=KK;
    ascrule[i0][i1][i2][1][1]='0'+n%KK;
    }
  return TRUE;
}

void definerule(unsigned long int n)
{int i0, i1, i2, i3, i4;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++) {
	ascrule[i0][i1][i2][i3][i4]='0'+ n%KK; n/=KK;
			 }
   
}

- setRule:sender 
{char ch[30]; int i, ii, j, jj, i0, i1, i2, i3, i4;
   wrru(ch,ascrule);
   [ruleNumber setStringValue: ch];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];   
  i4=j%KK; j/=KK;
  i3=j%KK; j/=KK;
  i2=j%KK; j/=KK;
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1][i2][i3][i4]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  return self;
}  

- setAllRules:sender {
char ch[WNML], tiempo[30], fecha[30];
int i, j, i0, i1, i2, i3, i4;
 struct tm  *timeptr;
 time_t  secsnow;

 time(&secsnow);
   timeptr = localtime(&secsnow);
   sprintf(tiempo,"%02d:%02d:%02d\n",
	timeptr->tm_hour, 
	timeptr->tm_min,
        timeptr->tm_sec);
   [tiTime setStringValue: tiempo];
   sprintf(fecha,"%d-%d-19%02d\n",
	((timeptr->tm_mon) + 1), 
	timeptr->tm_mday,
        timeptr->tm_year);
   [tiDat setStringValue: fecha];
  
  wrru(ch,ascrule);
  [ruleNumber setStringValue: ch];
  asctobin();
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
  for (i4=0; i4<KK; i4++) {
    j=KK*(KK*(KK*(KK*i0+i1)+i2)+i3)+i4;
    for (i=0; i<KK; i++) {
      [[ascru cellAt: i: j] setIntValue: NO];
      if (auxrule[i0][i1][i2][i3][i4]) [[ascru cellAt: i: j] setEnabled: NO];
      if (auxrule[i0][i1][i2][i3][i4]) [[ascru cellAt: i: j] setBordered: NO];
      }
    [[ascru cellAt: binrule[i0][i1][i2][i3][i4]: j] setIntValue: YES];
    }
   wrru(ch,ascrule);
   [ruleNumber setStringValue: ch];
   [probView loadProb: self];
   [self showProbability: pSliders];
   if (istot()) {
		asctotot();
		[totlRef setStringValue: "Totalistic"]; 
		[self setTotRules: self];
		}
   else if (isstot()) [totlRef setStringValue: "semitotalistic"];
   else {
	wrru(ch,&ascrule);
	[toFullNumber setStringValue: ch];
	[toascru setEmptySelectionEnabled: YES];
	[toascru selectCellAt: -1: 0];
	for (j=0; j<TS; j++) for (i=0; i<KK; i++) 
		[[toascru cellAt: i: j] setIntValue: NO];
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- idenRules:sender {int i0, i1, i2, i3, i4;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    ascrule[i0][i1][i2][i3][i4]=i2+'0';
  [self setAllRules: self];
return self;
}

- zeroRules:sender {int i0, i1, i2, i3, i4;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    ascrule[i0][i1][i2][i3][i4]='0';
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {
  granrule();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* for 2-state automata, group the neighborhoods by fours and  */
/* use ASCII letters base 16 - that is, 0-9, A-F.	       */
void wrru(c,ru) char *c, ru[KK][KK][KK][KK][KK]; {
int  i, j;
int  i0, i1, i2;
  j=0;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    i= 4*(2*(ru[i0][i1][i2][1][1]-'0')+(ru[i0][i1][i2][1][0]-'0'))+
        2*(ru[i0][i1][i2][0][1]-'0')+(ru[i0][i1][i2][0][0]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[WNML-j-2]=i;
  j++;
  }
c[WNML-1]=0;
}

/* for 2-state automata, group the neighborhoods by fours and */
/* use ASCII letters base 16 - that is, 0-9, A-F	      */
void wru(c) char *c; {wrru(c,ascrule);}

/* generate a random rule */
void granrule() {int i, i0, i1, i2, i3, i4;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) 
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++){
  i=(random()&0xFF)%KK;
  ascrule[i0][i1][i2][i3][i4]=i+'0';
  }
}

/* generate a random protected rule */
void granprule() {int i0, i1, i2, i3, i4, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
  if (i%8 == 0) j=random(); i++;
  if (auxrule[i0][i1][i2][i3][i4]==0) ascrule[i0][i1][i2][i3][i4]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender {int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- randomLine:sender {double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1]);
return self;
}

- sCellLine:sender {
  zerline();
  switch (dn) {
    case 1: putionj(1,0); break;
    case 2: ranplacor(); break;
    case 3: ransolcor(); break;
    case 5: ranplacor(); break;
    case 6: ransolcor(); break;
    default: putionj(1,0); break;}
return self;
}

- uniformLine:sender {ranblin(0.5,0.5); return self;}

/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender 
{unsigned long int b;  /*   char ch[20];   */
  b=[[sender selectedCell] tag];
   definerule(b); 
   [self setAllRules: self]; 
  return self;
}

/* - - - - - - - - - - - - -   G F ( 2 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf2rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf2rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
    gf2rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF2Rule:sender {
    gftoasc();
    [self setAllRules:self];
    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - -    S E M I T O T A L I S T I C   R U L E    - - - - - - - */
 
- setSemiState:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    strule[t%KK][t/KK]=s+'0';
    [toWindow setDocEdited:YES];
 /*   sttoasc();   */
return self;
  }
 
- enterSemiRule:sender {
    sttoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [stWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- setTotalisticState:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [toWindow setDocEdited:YES];
  return self;
  }
 
- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [toWindow setDocEdited:NO];
return self;
}

- protectTotRule:sender {int i, j, k;
    j=[sender selectedCol];
    k=tarule[j];
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setEnabled:  k];
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setBordered: k];
    tarule[j]=!k;
return self;
}

- setTotRule:sender {char ch[WNML]; int i, ii, jj;
  wrru(ch,ascrule);
  [ruleNumber setStringValue: ch];
  ii= [sender selectedRow];
  jj= [sender selectedCol];
  ttrule[jj]='0'+ii;
  for (i=0; i<KK; i++) [[toascru cellAt: i: jj] setIntValue: NO];
  [[toascru cellAt: ii: jj] setIntValue: YES];
  [self setTotRules: self];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
//  wrru(ch,ascrule);
//  [ruleNumber setStringValue: ch];
  totoasc();
  asctobin();
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  wrru(ch,ascrule);
  [toFullNumber setStringValue: ch];
   [probView loadProb: self];
   if      (istot()) {
		asctotot();
		[totlRef setStringValue: "totalistic"];
		[toRuleNumber setIntValue: totonu(0)];
		}
    else if (isstot()) [totlRef setStringValue: "semitotalistic"];
    else        [totlRef setStringValue: " "];
return self;
}

- freeAllTotRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    tazero();
return self;
}

- zeroTotRules:sender 
    {ttzero(); tazero(); totoasc(); [self setTotRules: self]; return self;}

- ranTotRules:sender {grantotrule(); [self setTotRules: self]; return self;}

- ranPTotRules:sender {granptotrule(); [self setTotRules: self]; return self;}

/* generate a random protected totalistic rule */
void granptotrule() {int i0, i, j;
i=0; j=0;
for (i0=0; i0<TS; i0++) {
          if (i%8 == 0) j=random();  i++;
  	  if (tarule[i0]==0) ttrule[i0]='0'+j%KK;
	  j/=KK;
	  }
}

/* generate a random totalistic rule */
void grantotrule() {int i; for (i=0; i<TS; i++) ttrule[i]='0'+random()%KK;}

/* clear ttrule to zeroes */
void ttzero() {int i; for (i=0; i<TS; i++)  ttrule[i]='0';}

/* clear tarule to zeroes */
void tazero() {int i; for (i=0; i<TS; i++)  tarule[i]=0;}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophilic:sender {
//  oxtoasc(xr);
  ranvachrul(xp);
  [self setAllRules: self];
return self;
}

- xenophobic:sender {
//  oxtoasc(xr);
  ranvachrul(xq);
  [self setAllRules: self];
return self;
}

int ran2of3(a,b) int a, b; {
if ((random()%1001)<500) return a; else return b;
}

int ran3of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
return c;
}

/* generate a random variable choice rule */
void ranvachrul(c) char *c; {int i0, i1, i2, i3, i4, i;
i=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) 
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++){
  switch (c[KK*(KK*KK*(KK*i0+i1)+(KK*i2+i3))+i4]-'0') {
    case 0: break;
    case 1: i=0; break;
    case 2: i=1; break;
    case 3: i=ran2of3(0,1); break;
 /*   case 4: i=ran2of3(0,1); break;
    case 5: i=ran2of3(1,2); break;
    case 6: i=ran2of3(2,0); break;
    case 7: i=ran3of3(0,1,2); break;    */
    default: i=0; break;}
    ascrule[i0][i1][i2][i3][i4]='0'+i;
  }
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
id  z;
int i0, i1, i2;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    [z setIntValue: (int)ascrule[i0][i1][i2]-'0'];
    z=[z nextText];
    }    
return self;
}

- enterDesign:sender {
int i, k, i0, i1, i2, i3, i4;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i4=k%KK; k/=KK;
    i3=k%KK; k/=KK;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1][i2][i3][i4]=(k<KK?k:0)+'0';
    auxrule[i0][i1][i2][i3][i4]=(k<KK?1:0);
    }
  [self setAllRules: self];
return self;
}

int permut(k,n) int k, n; {
  switch (n) {
    case 0: break;
    case 1: if (k==0) k=1; else if (k==1) k=0; break;
    default: break;}
  return k;
}

/* - - - - - - -    A R I T H M E T I C    C O M B I N A T I O N   - - - - - */

 - arithmCombs:sender {
int i0, i1, i2, i3, i4;
binrular aza, bzb, czc;
   [self readWRule: [twoRules cellAt: 0: 0]];
   asctobin();
   bincopy(&aza,binrule);
   binprint(aza);
   [self readWRule: [twoRules cellAt: 1: 0]];
   asctobin();
   bincopy(&bzb,binrule);
   binprint(bzb);
   switch ([sender selectedRow]) {
      case 0: binsum(&czc,aza,bzb); break;
      case 1: binprod(&czc,aza,bzb); break;
      default: printf("arithCombs\n"); 
   break;}
   binprint(czc);
   for (i0=0; i0<KK ;i0++) 
      for (i1=0; i1<KK ;i1++) 
	 for (i2=0; i2<KK ;i2++) 
	    for (i3=0; i3<KK; i3++)
	      for (i4=0; i4<KK; i4++)
               binrule[i0][i1][i2][i3][i4]=czc.five[i0][i1][i2][i3][i4]; 
   bintoasc();
   [self setAllRules: self];
return self;
}

- initTwoRules:sender {
char ch[20];
   granrule();
   wrru(ch,ascrule);
   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: ch];
return self;
}

/* copy one binary rule from another */
void bincopy(rz,rx) binrular *rz; int rx[KK][KK][KK][KK][KK];
{int i0, i1, i2, i3, i4;
   for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
         for (i2=0; i2<KK; i2++)
            for (i3=0; i3<KK; i3++)
              for (i4=0; i4<KK; i4++)
               rz->five[i0][i1][i2][i3][i4]=rx[i0][i1][i2][i3][i4]+'0';
}


 /*  fill ascrule from binrule */
void byntoasc(as, bi) char  as[KK][KK][KK][KK][KK]; int bi[KK][KK][KK][KK][KK];
{ int i0, i1, i2, i3, i4;
   for(i0=0; i0 < KK; i0++)
   for(i1=0; i1 < KK; i1++)
   for(i2=0; i2 < KK; i2++)
   for(i3=0; i3 < KK; i3++)
   for(i4=0; i4 < KK; i4++)
     as[i0][i1][i2][i3][i4] = bi[i0][i1][i2][i3][i4] + '0';
   }


/*fill ascrule from binrule*/
void bintoasc()
{int i0, i1, i2, i3, i4;
   for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
         for (i2=0; i2<KK; i2++)
            for (i3=0; i3<KK; i3++)
              for (i4=0; i4<KK; i4++)
               ascrule[i0][i1][i2][i3][i4]=binrule[i0][i1][i2][i3][i4]+'0';
}

/*sum two binary rules mod KK*/
void binsum(rz,rx,ry) binrular *rz, rx, ry;
{int i; for (i=0; i<DS; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*multiply two binary rules mod KK*/
void binprod(rz,rx,ry) binrular *rz, rx, ry;
{int i; for (i=0; i<DS; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*print a binary rule (all 16 numbers)*/
void binprint(rz) binrular rz; {int i;
      for (i=0; i<DS; i++) printf("%c",rz.one[i]+'0');
      printf("\n");
}

/* - - - - - - - - - - -  C O M P O S I T E   R U L E  - - - - - - - - - - -*/ 

- composRule:sender {
int ru1, ru2, i0, i1, i2, i3, i4;
int br1[KK][KK][KK], br2[KK][KK][KK];
  ru1=[[composRuleNumb cellAt: 0: 0] intValue];
  ru2=[[composRuleNumb cellAt: 1: 0] intValue];
  numtobin21(br1, ru1);
  numtobin21(br2, ru2);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    ascrule[i0][i1][i2][i3][i4] = 
	br2[br1[i0][i1][i2]] [br1[i1][i2][i3]] [br1[i2][i3][i4]] + '0';
  [self setAllRules:self];
return self;
}

- compxRule:sender {int i;
   i=[[composRuleNumb cellAt: 0: 0] intValue];
   [[composRuleNumb cellAt: 0: 0] setIntValue: [[composRuleNumb cellAt: 1: 0]
   intValue]];
   [[composRuleNumb cellAt: 1: 0] setIntValue: i];
 return self;
}

- comprRule:sender { 
  [[composRuleNumb cellAt:0 :0] setIntValue: random()%255];
  [[composRuleNumb cellAt:1 :0] setIntValue: random()%255];
return self;
}


void numtobin21(ru,n) int ru[KK][KK][KK], n; {int i, j, i0, i1, i2;
i=n;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++){
  j=i%KK; i/=KK;
  ru[i0][i1][i2]=j;
  }
}


/* - - - - - - - - special rule box management - - - - - - - - */

- loadSpecialRule:sender {char *ch;
 ch=(char *) malloc(strlen([[sender selectedCell] title]));
 strcpy(ch,[[sender selectedCell] title]);
 if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
 if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel:arithmRuleBox];
 if (strcmp(ch,"composite")==0)   [self loadLowerPanel:composRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox {NXRect bxRect, loRect;
  [specBigBox  getFrame:&bxRect];
  [thisRuleBox getFrame:&loRect];
  [specBigBox  setContentView: [thisRuleBox contentView]];
  loRect.origin.x = (bxRect.size.width - loRect.size.width)/2.0;
  loRect.origin.y = (bxRect.size. height - loRect.size.height)/2.0;
  [specLilBox setFrame: &bxRect];
  [specLilBox display];
  [specBigBox display];
 return self;
}

/*   - -- - - -- - - - - - author box management  - - - - -- -- */

- loadBox:sender {NXRect bx3Rect, lo3Rect;  
  if ((auxBox==NULL) || (auxBox==authorBox)) theBox=automatonBox;
  else if (auxBox==automatonBox) theBox=authorBox;
  auxBox=theBox;

  [anotherBigBox getFrame:&bx3Rect];
  [theBox getFrame:&lo3Rect];
  [anotherBigBox  setContentView: [theBox contentView]];
  lo3Rect.origin.x = (bx3Rect.size.width - lo3Rect.size.width)/2.0;
  lo3Rect.origin.y = (bx3Rect.size.height - lo3Rect.size.height)/2.0;
  [anotherLilBox setFrame: &bx3Rect];
  [anotherLilBox display];
  [anotherBigBox display]; 
 return self;
}
 
@end

/* clear srule to zeroes */
void stzero() {int i, j;
  for (i=0; i<KK; i++) for (j=0; j<TS-1; j++)  strule[i][j]='0';}

/* clear gf2rule to zeroes */
void gfzero() {int i; for (i=0; i<13; i++) gf2rule[i]='0';}


/* clear auxrule to zeroes */
void auxzero() {int i0, i1, i2, i3, i4;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  auxrule[i0][i1][i2][i3][i4]=0;
}

/* generate a random line of cells in arr1 with assigned probabilities */
void ranblin(p1, p2) double p1, p2; {int i, i1; double p;
  p=p1+p2;
  for (i=0; i<AL; i++) {
    if (random()%1000 < (int)((1000.0*p1)/p)) arr1[i]=0; else arr1[i]=1;
    }
}

/* change a GF2 rule to general rule */
void gftoasc() {int i0, i1, i2, i3, i4;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) 
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) 
  ascrule[i0][i1][i2][i3][i4]=
    (i0*((gf2rule[0]-'0')*i0+(gf2rule[9]-'0'))+
     i0*(gf2rule[1]-'0')*i1+
     i0*(gf2rule[2]-'0')*i2+
     i1*((gf2rule[3]-'0')*i0+(gf2rule[10]-'0'))+
     i1*(gf2rule[4]-'0')*i1+
     i1*(gf2rule[5]-'0')*i2+
     i2*((gf2rule[6]-'0')*i0+(gf2rule[11]-'0'))+
     i2*(gf2rule[7]-'0')*i1+
     i2*(gf2rule[8]-'0')*i2+
    (gf2rule[12]-'0') )%KK+'0';
} 
 
/* copy saved rule #n into active rule */
void xtoasc2(n)  int n; { int i, i0, i1, i2, i3, i4;char a[DS];
//xmenu(n+1);
 for (i=0; i<DS; i++) a[i]=ixrule[n][i];
          i=0;
            for (i0=0; i0<KK; i0++){
	      for (i1=0; i1<KK; i1++){
		for (i2=0; i2<KK; i2++){ 
  		   for(i3=0; i3<KK; i3++) {
		      for(i4=0; i4<KK; i4++){
			 ascrule[i0][i1][i2][i3][i4]=a[i];
			    i++;
					     }
					   }
					}
				     }
			          }

}


/*  make a list of a reversible rules  */

void rever2(){
char chb[10], chc[10];
char ii[4][KK][KK][KK][KK][KK], wnum[4][15];
char asqrule[KK][KK][KK][KK][KK], bsqrule[KK][KK][KK][KK][KK];
int kay[KK];
int 		brul[KK][KK][KK][KK][KK];
int 		crul[KK][KK][KK][KK][KK];
/* int         drul[KK][KK][KK][KK][KK][KK][KK];
   int     erul[KK][KK][KK][KK][KK][KK][KK][KK][KK];  */
int i00000,i00001,i00010,i00011,i00100,i00101,i00110,i00111;
int i01000,i01001,i01010,i01011,i01100,i01101,i01110,i01111;
int i10000,i10001,i10010,i10011,i10100,i10101,i10110,i10111;
int i11000,i11001,i11010,i11011,i11100,i11101,i11110,i11111;
/* int j0, j1, j2, j3, j4, j5, j6, j7, j8, j9;  */
int i, k, kk, l, m ,mm;
k=kk=l=m=0;
for(i=0; i<KK; i++) kay[i]=0;
i=0;

printf (" reversibles - unicycles \n" );

for(i00000=0; i00000<KK; i00000++) { brul[0][0][0][0][0]=i00000;
		if(kay[i00000]>(KK*KK*KK*KK)) break; kay[i00000]++;
for(i11111=0; i11111<KK; i11111++) { brul[1][1][1][1][1]=i11111;
		if(i11111==i00000) continue;
		if(kay[i11111]>(KK*KK*KK*KK)) break; kay[i11111]++;

printf("reversibles - bicycles\n ");

for(i00100=0; i00100<KK; i00100++) {  brul[0][0][1][0][0]=i00100;
		if(kay[i00100]>(KK*KK*KK*KK)) break; kay[i00100]++;

for(i11011=0; i11011<KK; i11011++) {  brul[1][1][0][1][1]=i11011;
		if(i11011==i00100) continue;
		if(kay[i11011]>(KK*KK*KK*KK)) break; kay[i11011]++;


for(i01110=0; i01110<KK; i01110++) {  brul[0][1][1][1][0]=i01110;
		if(kay[i01110]>(KK*KK*KK*KK)) break; kay[i01110]++;

for(i10001=0; i10001<KK; i10001++) {  brul[1][0][0][0][1]=i10001;
		if(i01110==i10001) continue;
/*		if(i01110==i00100 && i10001==i11011)continue;
		if(i01110==i11011 && i10001==i00100)continue; */
		if(kay[i10001]>(KK*KK*KK*KK)) break; kay[i10001]++;

for(i10101=0; i10101<KK; i10101++) {  brul[1][0][1][0][1]=i10101;
		if(kay[i10101]>(KK*KK*KK*KK)) break; kay[i10101]++;

for(i01010=0; i01010<KK; i01010++) {  brul[0][1][0][1][0]=i01010;
		if(i10101==i01010) continue;
/*		if(i10101==i00100 && i01010==i11011) continue;
		if(i10101==i11011 && i01010==i00100) continue;
		if(i10101==i01110 && i01010==i10001) continue;
		if(i10101==i10001 && i01010==i01110) continue;*/
		if(kay[i01010]>(KK*KK*KK*KK)) break; kay[i01010]++;


// printf (" reversible - tricycles \n ");

for(i00001=0; i00001<KK; i00001++) {  brul[0][0][0][0][1]=i00001;
		if(kay[i00001]>(KK*KK*KK*KK)) break; kay[i00001]++;
for(i10000=0; i10000<KK; i10000++) {  brul[1][0][0][0][0]=i10000;
		if(i00001==i00100 && i00100==i10000) continue; 
		if(kay[i10000]>(KK*KK*KK*KK)) break; kay[i10000]++;

for(i00010=0; i00010<KK; i00010++) {  brul[0][0][0][1][0]=i00010;
		if(kay[i00010]>(KK*KK*KK*KK)) break; kay[i00010]++;
for(i01000=0; i01000<KK; i01000++) {  brul[0][1][0][0][0]=i01000;
		if(i00010==i01000 && i01000==i01010) continue;
/*		if(i00010==i00001 && i01000==i00100 && i01010==i10000)continue;
		if(i00010==i00100 && i01000==i10000 && i01010==i00001)continue;
		if(i00010==i10000 && i01000==i00001 && i01010==i00100)continue;
*/		
		if(kay[i01000]>(KK*KK*KK*KK)) break; kay[i01000]++;


for(i00011=0; i00011<KK; i00011++) {  brul[0][0][0][1][1]=i00011;
		if(kay[i00011]>(KK*KK*KK*KK)) break; kay[i00011]++;
for(i11000=0; i11000<KK; i11000++) {  brul[1][1][0][0][0]=i11000;
		if(i00011==i11000 && i11000==i11011) continue;
/*		if(i00011==i00001 && i11000==i00100 && i11011==i10000)continue;
		if(i00011==i00010 && i11000==i01000 && i11011==i00001)continue;
		if(i00011==i00100 && i11000==i10000 && i11011==i00010)continue;
		if(i00011==i01000 && i11000==i00001 && i11011==i00100)continue;
		if(i00011==i10000 && i11000==i00010 && i11011==i01000)continue;
*/
		if(kay[i11000]>(KK*KK*KK*KK)) break; kay[i11000]++;

for(i00101=0; i00101<KK; i00101++) {  brul[0][0][1][0][1]=i00101;
		if(kay[i00101]>(KK*KK*KK*KK)) break; kay[i00101]++;
for(i10100=0; i10100<KK; i10100++) {  brul[1][0][1][0][0]=i10100;
		if(i00101==i11000 && i10100==i10001) continue;
/*		if(i00101==i00001 && i10100==i00100 && i10001==i10000)continue;
		if(i00101==i00010 && i10100==i01000 && i10001==i00001)continue;
		if(i00101==i00100 && i10100==i10000 && i10001==i00010)continue;
		if(i00101==i01000 && i10100==i00001 && i10001==i00100)continue;
		if(i00101==i10000 && i10100==i00010 && i10001==i01000)continue;
		if(i00101==i00011 && i10100==i00100 && i10001==i11000)continue;
		if(i00101==i00100 && i10100==i11000 && i10001==i00011)continue;
		if(i00101==i11000 && i10100==i00011 && i10001==i00100)continue;
	*/
	if(kay[i10100]>(KK*KK*KK*KK)) break; kay[i10100]++;		


for(i00110=0; i00110<KK; i00110++) {  brul[0][0][1][1][0]=i00110;
		if(kay[i00110]>(KK*KK*KK*KK)) break; kay[i00110]++;
for(i01100=0; i01100<KK; i01100++) {  brul[0][1][1][0][0]=i01100;
		if(i00110==i01100 && i01100==i01010) continue;
/*		if(i00110==i00001 && i01100==i00100 && i01010==i10000)continue;
		if(i00110==i00010 && i01100==i01000 && i01010==i00001)continue;
		if(i00110==i00100 && i01100==i10000 && i01010==i00010)continue;
		if(i00110==i01000 && i01100==i00001 && i01010==i00100)continue;
		if(i00110==i10000 && i01100==i00010 && i01010==i01000)continue;
		if(i00110==i00011 && i01100==i00100 && i01010==i11000)continue;
		if(i00110==i00100 && i01100==i11000 && i01010==i00011)continue;
		if(i00110==i11000 && i01100==i00011 && i01010==i00100)continue;
		if(i00110==i00101 && i01100==i00100 && i01010==i10100)continue;
		if(i00110==i00100 && i01100==i10100 && i01010==i00101)continue;
		if(i00110==i10100 && i01100==i00101 && i01010==i00100)continue;
*/
		if(kay[i01100]>(KK*KK*KK*KK)) break; kay[i01100]++;


for(i00111=0; i00111<KK; i00111++) { brul[0][0][1][1][1]=i00111;
		if(kay[i00111]>(KK*KK*KK*KK)) break; kay[i00111]++;
for(i11100=0; i11100<KK; i11100++) { brul[1][1][1][0][0]=i11100;
		if(i00111==i11100 && i11100==i11011) continue;
/*		if(i00111==i00001 && i11100==i00100 && i11011==i10000)continue;
		if(i00111==i00010 && i11100==i01000 && i11011==i00001)continue;
		if(i00111==i00100 && i11100==i10000 && i11011==i00010)continue;
		if(i00111==i01000 && i11100==i00001 && i11011==i00100)continue;
		if(i00111==i10000 && i11100==i00010 && i11011==i01000)continue;
		if(i00111==i00011 && i11100==i00100 && i11011==i11000)continue;
		if(i00111==i00100 && i11100==i11000 && i11011==i00011)continue;
		if(i00111==i11000 && i11100==i00011 && i11011==i00100)continue;

		if(i00111==i00101 && i11100==i00100 && i11011==i10100)continue;
		if(i00111==i00100 && i11100==i10100 && i11011==i00101)continue;
		if(i00111==i10100 && i11100==i00101 && i11011==i00100)continue;

		if(i00111==i00110 && i11100==i00100 && i11011==i01100)continue;
		if(i00111==i00100 && i11100==i01100 && i11011==i00110)continue;
		if(i00111==i01100 && i11100==i00110 && i11011==i00100)continue;
*/
		if(kay[i11100]>(KK*KK*KK*KK)) break; kay[i11100]++;



//printf (" old McDonald had a farm ");


for(i01111=0; i01111<KK; i01111++) {  brul[0][1][1][1][1]=i01111;
		if(kay[i01111]>(KK*KK*KK*KK)) break; kay[i01111]++;
for(i11110=0; i11110<KK; i11110++) {  brul[1][1][1][1][0]=i11110;
		if(i01111==i00100 && i00100==i11110) continue; 
		if(kay[i11110]>(KK*KK*KK*KK)) break; kay[i11110]++;


for(i10111=0; i10111<KK; i10111++) {  brul[1][0][1][1][1]=i10111;
		if(kay[i10111]>(KK*KK*KK*KK)) break; kay[i10111]++;

for(i11101=0; i11101<KK; i11101++) {  brul[1][1][1][0][1]=i11101;
		if(i10111==i11101 && i11101==i11011) continue;
/*		if(i10111==i01111 && i11101==i00100 && i11011==i11110)continue;
		if(i10111==i00100 && i11101==i11110 && i11011==i01111)continue;
		if(i10111==i11110 && i11101==i01111 && i11011==i00100)continue;	
*/	
		if(kay[i11101]>(KK*KK*KK*KK)) break; kay[i11101]++;


for(i01101=0; i01101<KK; i01101++) {  brul[0][1][1][0][1]=i01101;
		if(kay[i01101]>(KK*KK*KK*KK)) break; kay[i01101]++;

for(i10110=0; i10110<KK; i10110++) {  brul[1][0][1][1][0]=i10110;
		if(i01101==i10110 && i10110==i11011) continue;
/*		if(i01101==i01111 && i10110==i00100 && i11011==i11110)continue;
		if(i01101==i00100 && i10110==i11110 && i11011==i01111)continue;
		if(i01101==i11110 && i10110==i01111 && i11011==i00100)continue;
		if(i01101==i10111 && i10110==i00100 && i11011==i11101)continue;
		if(i01101==i00100 && i10110==i11101 && i11011==i10111)continue;
		*/
if(kay[i10110]>(KK*KK*KK*KK)) break; kay[i10110]++;


for(i11001=0; i11001<KK; i11001++) {  brul[1][1][0][0][1]=i11001;
		if(kay[i11001]>(KK*KK*KK*KK)) break; kay[i11001]++;
for(i10011=0; i10011<KK; i10011++) {  brul[1][0][0][1][1]=i10011;
		if(i11001==i10110 && i10011==i10001) continue;
/*		if(i11001==i01111 && i10011==i00100 && i10001==i11110)continue;
		if(i11001==i10111 && i10011==i11101 && i10001==i01111)continue;
		if(i11001==i00100 && i10011==i11110 && i10001==i10111)continue;
		if(i11001==i11101 && i10011==i01111 && i10001==i00100)continue;
		if(i11001==i11110 && i10011==i10111 && i10001==i11101)continue;
		if(i11001==i01101 && i10011==i00100 && i10001==i10110)continue;
 		if(i11001==i00100 && i10011==i10110 && i10001==i01101)continue;
		if(i11001==i10110 && i10011==i01101 && i10001==i00100)continue;
*/
		if(kay[i10011]>(KK*KK*KK*KK)) break; kay[i10011]++;



for(i01011=0; i01011<KK; i01011++) {  brul[0][1][0][1][1]=i01011;
		if(kay[i01011]>(KK*KK*KK*KK)) break; kay[i01011]++;
for(i11010=0; i11010<KK; i11010++) {  brul[1][1][0][1][0]=i11010;
		if(i01011==i11010 && i11010==i01010) continue;
/*		if(i01011==i01111 && i11010==i00100 && i01010==i11110)continue;
		if(i01011==i10111 && i11010==i11101 && i01010==i01111)continue;
 		if(i01011==i00100 && i11010==i11110 && i01010==i10111)continue;
		if(i01011==i11101 && i11010==i01111 && i01010==i00100)continue;
		if(i01011==i11110 && i11010==i10111 && i01010==i11101)continue;
		if(i01011==i01101 && i11010==i00100 && i01010==i10110)continue;
		if(i01011==i00100 && i11010==i10110 && i01010==i01101)continue;
		if(i01011==i10110 && i11010==i01101 && i01010==i00100)continue;
		if(i01011==i11001 && i11010==i00100 && i01010==i10011)continue;
		if(i01011==i00100 && i11010==i10011 && i01010==i11001)continue;
		if(i01011==i10011 && i11010==i11001 && i01010==i00100)continue;		
	*/
	if(kay[i11010]>(KK*KK*KK*KK)) break; kay[i11010]++;


for(i01001=0; i01001<KK; i01001++) {  brul[0][1][0][0][1]=i01001;
		if(kay[i01001]>(KK*KK*KK*KK)) break; kay[i01001]++;
for(i10010=0; i10010<KK; i10010++) {  brul[1][0][0][1][0]=i10010;
		if(i01001==i10110 && i10010==i10001) continue;
/*
		if(i01001==i01111 && i10010==i00100 && i10001==i11110)continue;

		if(i01001==i10111 && i10010==i11101 && i10001==i01111)continue;

		if(i01001==i00100 && i10010==i11110 && i10001==i10111)continue;

		if(i01001==i11101 && i10010==i01111 && i10001==i00100)continue;

		if(i01001==i11110 && i10010==i10111 && i10001==i11101)continue;

		if(i01001==i01101 && i10010==i00100 && i10001==i10110)continue;

		if(i01001==i00100 && i10010==i10110 && i10001==i01101)continue;

		if(i01001==i10110 && i10010==i01101 && i10001==i00100)continue;

		if(i01001==i11001 && i10010==i00100 && i10001==i10011)continue;

		if(i01001==i00100 && i10010==i10011 && i10001==i11001)continue;

		if(i01001==i10011 && i10010==i11001 && i10001==i00100)continue;  

		if(i01001==i01011 && i10010==i00100 && i10001==i11010)continue;
                         
		if(i01001==i00100 && i10010==i11010 && i10001==i01011)continue;

		if(i01001==i11010 && i10010==i01011 && i10001==i00100)continue;  
*/
		if(kay[i10010]>(KK*KK*KK*KK)) break; kay[i10010]++;

  

kk++;
if (runiq(brul,crul))  {

	byntoasc(asqrule,brul);
	byntoasc(bsqrule,crul);
	mm=allperm(wnum,ii,asqrule);
	wrru(chb,asqrule);
	wrru(chc,bsqrule);
	printf(" runiq: %s    %s    %s   (%3d)/%3d\n", wnum[mm],chb,chc,++k,kk);
	kk=0;


}

kay[i10010]--;}
kay[i01001]--;}
kay[i11010]--;}
kay[i01011]--;}
kay[i10011]--;}
kay[i11001]--;}
kay[i10110]--;}
kay[i01101]--;}

kay[i11101]--;}
kay[i10111]--;}
kay[i11110]--;}
kay[i01111]--;}
kay[i11100]--;}
kay[i00111]--;}
kay[i01100]--;}
kay[i00110]--;}

kay[i10100]--;}
kay[i00101]--;}
kay[i11000]--;}
kay[i00011]--;}
kay[i01000]--;}
kay[i00010]--;}
kay[i10000]--;}
kay[i00001]--;}

kay[i01010]--;}
kay[i10101]--;}
kay[i10001]--;}
kay[i01110]--;}
kay[i11011]--;}
kay[i00100]--;}
kay[i11111]--;}
kay[i00000]--;}

}


int ufmult() {
int j, j0, j1, j2, j3, j4, m[KK];
asctobin();
for (j=0; j<KK; j++) m[j]=0;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
  m[binrule[j0][j1][j2][j3][j4]]++;
for (j=1; j<KK; j++) if (m[j]!=m[0]) return 0;
return 1;
}


void rever3() {
char chb[40], chc[40];
char ii[4][KK][KK][KK][KK][KK], wnum[4][15];
char asqrule[KK][KK][KK][KK][KK], bsqrule[KK][KK][KK][KK][KK];

int i, k, kk, l, m ,mm;

int kay[KK];
int brul[KK][KK][KK][KK][KK], crul[KK][KK][KK][KK][KK];

int i00000,i00001,i00010,i00011,i00100,i00101,i00110,i00111;
int i01000,i01001,i01010,i01011,i01100,i01101,i01110,i01111;
int i10000,i10001,i10010,i10011,i10100,i10101,i10110,i10111;
int i11000,i11001,i11010,i11011,i11100,i11101,i11110,i11111;
/*     int j0,j1,j2,j3,j4,j5;   */

k=kk=l=m=0;

printf("hello from rever\n");
k=l=m=0;
for (i=0; i<KK; i++) kay[i]=0;
i=0;
for (i00000=0; i00000<KK; i00000++) {brul[0][0][0][0][0]=i00000; if (kay[i00000]>(KK*KK*KK*KK)) break; kay[i00000]++;
for (i00001=0; i00001<KK; i00001++) {brul[0][0][0][0][1]=i00001; if (kay[i00001]>(KK*KK*KK*KK)) break; kay[i00001]++;
for (i00010=0; i00010<KK; i00010++) {brul[0][0][0][1][0]=i00010; if (kay[i00010]>(KK*KK*KK*KK)) break; kay[i00010]++;
for (i00011=0; i00011<KK; i00011++) {brul[0][0][0][1][1]=i00011; if (kay[i00011]>(KK*KK*KK*KK)) break; kay[i00011]++; 
for (i00100=0; i00100<KK; i00100++) {brul[0][0][1][0][0]=i00100; if (kay[i00100]>(KK*KK*KK*KK)) break; kay[i00100]++;
for (i00101=0; i00101<KK; i00101++) {brul[0][0][1][0][1]=i00101; if (kay[i00101]>(KK*KK*KK*KK)) break; kay[i00101]++;
for (i00110=0; i00110<KK; i00110++) {brul[0][0][1][1][0]=i00110; if (kay[i00110]>(KK*KK*KK*KK)) break; kay[i00110]++;
for (i00111=0; i00111<KK; i00111++) {brul[0][0][1][1][1]=i00111; if (kay[i00111]>(KK*KK*KK*KK)) break; kay[i00111]++;

for (i01000=0; i01000<KK; i01000++) {brul[0][1][0][0][0]=i01000; if (kay[i01000]>(KK*KK*KK*KK)) break; kay[i01000]++;
for (i01001=0; i01001<KK; i01001++) {brul[0][1][0][0][1]=i01001; if (kay[i01001]>(KK*KK*KK*KK)) break; kay[i01001]++;
for (i01010=0; i01010<KK; i01010++) {brul[0][1][0][1][0]=i01010; if (kay[i01010]>(KK*KK*KK*KK)) break; kay[i01010]++;
for (i01011=0; i01011<KK; i01011++) {brul[0][1][0][1][1]=i01011; if (kay[i01011]>(KK*KK*KK*KK)) break; kay[i01011]++;
for (i01100=0; i01100<KK; i01100++) {brul[0][1][1][0][0]=i01100; if (kay[i01100]>(KK*KK*KK*KK)) break; kay[i01100]++;
for (i01101=0; i01101<KK; i01101++) {brul[0][1][1][0][1]=i01101; if (kay[i01101]>(KK*KK*KK*KK)) break; kay[i01101]++;
for (i01110=0; i01110<KK; i01110++) {brul[0][1][1][1][0]=i01110; if (kay[i01110]>(KK*KK*KK*KK)) break; kay[i01110]++;
for (i01111=0; i01111<KK; i01111++) {brul[0][1][1][1][1]=i01111; if (kay[i01111]>(KK*KK*KK*KK)) break; kay[i01111]++;

for (i10000=0; i10000<KK; i10000++) {brul[1][0][0][0][0]=i10000; if (kay[i10000]>(KK*KK*KK*KK)) break; kay[i10000]++;
for (i10001=0; i10001<KK; i10001++) {brul[1][0][0][0][1]=i10001; if (kay[i10001]>(KK*KK*KK*KK)) break; kay[i10001]++;
for (i10010=0; i10010<KK; i10010++) {brul[1][0][0][1][0]=i10010; if (kay[i10010]>(KK*KK*KK*KK)) break; kay[i10010]++;
for (i10011=0; i10011<KK; i10011++) {brul[1][0][0][1][1]=i10011; if (kay[i10011]>(KK*KK*KK*KK)) break; kay[i10011]++;
for (i10100=0; i10100<KK; i10100++) {brul[1][0][1][0][0]=i10100; if (kay[i10100]>(KK*KK*KK*KK)) break; kay[i10100]++;

for (i10101=0; i10101<KK; i10101++) {brul[1][0][1][0][1]=i10101; if (kay[i10101]>(KK*KK*KK*KK)) break; kay[i10101]++;

for (i10110=0; i10110<KK; i10110++) {brul[1][0][1][1][0]=i10110; if (kay[i10110]>(KK*KK*KK*KK)) break; kay[i10110]++;
for (i10111=0; i10111<KK; i10111++) {brul[1][0][1][1][1]=i10111; if (kay[i10111]>(KK*KK*KK*KK)) break; kay[i10111]++;

for (i11000=0; i11000<KK; i11000++) {brul[1][1][0][0][0]=i11000; if (kay[i11000]>(KK*KK*KK*KK)) break; kay[i11000]++;
for (i11001=0; i11001<KK; i11001++) {brul[1][1][0][0][1]=i11001; if (kay[i11001]>(KK*KK*KK*KK)) break; kay[i11001]++;
for (i11010=0; i11010<KK; i11010++) {brul[1][1][0][1][0]=i11010; if (kay[i11010]>(KK*KK*KK*KK)) break; kay[i11010]++;
for (i11011=0; i11011<KK; i11011++) {brul[1][1][0][1][1]=i11011; if (kay[i11011]>(KK*KK*KK*KK)) break; kay[i11011]++;
for (i11100=0; i11100<KK; i11100++) {brul[1][1][1][0][0]=i11100; if (kay[i11100]>(KK*KK*KK*KK)) break; kay[i11100]++;
for (i11101=0; i11101<KK; i11101++) {brul[1][1][1][0][1]=i11101; if (kay[i11101]>(KK*KK*KK*KK)) break; kay[i11101]++;
for (i11110=0; i11110<KK; i11110++) {brul[1][1][1][1][0]=i11110; if (kay[i11110]>(KK*KK*KK*KK)) break; kay[i11110]++;
for (i11111=0; i11111<KK; i11111++) {brul[1][1][1][1][1]=i11111; if (kay[i11111]>(KK*KK*KK*KK)) break; kay[i11111]++;

kk++;

if (runiq(brul,crul))  {
	byntoasc(asqrule,brul);
	byntoasc(bsqrule,crul);
	mm=allperm(wnum,ii,asqrule);
	wrru(chb,asqrule);
	wrru(chc,bsqrule);
	printf(" runiq: %s    %s    %s   (%3d)/%3d\n", wnum[mm],chb,chc,++k,kk);
	kk=0;

}


/*  if (runiq(brul,crul)) {
    printf("runiq, k = %3d: ",++k);
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) for (j2=0; j2<KK; j2++) 
	printf("%1d",brul[j0][j1][j2]);
    printf(" --- ");
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) for (j2=0; j2<KK; j2++)
	printf("%1d",crul[j0][j1][j2]);
    printf("\n");
    }   */
//  if (suniq(brul,drul)) {
//    printf("suniq, l = %3d: ",++l);
//    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
//    printf(" ---\n");
//     for (j0=0; j0<KK; j0++)
//       { 
//       for (j1=0; j1<KK; j1++) 
//       for (j2=0; j2<KK; j2++) for (j3=0; j3<KK; j3++)
// 	printf("%1d",drul[j0][j1][j2][j3]);
//       printf("\n");
//       } /* end for */
//    }   /* end if  */
//   if (tuniq(brul,erul)) {
//     printf("tuniq, m = %3d: ",++m);
//     for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
//     printf(" ---\n");
//     for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++)
//     for (j2=0; j2<KK; j2++)
//       { 
//       for (j3=0; j3<KK; j3++) 
//       for (j4=0; j4<KK; j4++) for (j5=0; j5<KK; j5++)
// 	printf("%1d",erul[j0][j1][j2][j3][j4][j5]);
//       printf("\n");
//       } /* end for */
//     }   /* end if  */




kay[i11111]--;}
kay[i11110]--;}
kay[i11101]--;}
kay[i11100]--;}
kay[i11011]--;}
kay[i11010]--;}
kay[i11001]--;}
kay[i11000]--;}

kay[i10111]--;}
kay[i10110]--;}
kay[i10101]--;}
kay[i10100]--;}
kay[i10011]--;}
kay[i10010]--;}
kay[i10001]--;}
kay[i10000]--;}

kay[i01111]--;}
kay[i01110]--;}
kay[i01101]--;}
kay[i01100]--;}
kay[i01011]--;}
kay[i01010]--;}
kay[i01001]--;}
kay[i01000]--;}

kay[i00111]--;}
kay[i00110]--;}
kay[i00101]--;}
kay[i00100]--;}
kay[i00011]--;}
kay[i00010]--;}
kay[i00001]--;}
kay[i00000]--;}

}

/* end RulePanel.m */
