
/* 
 * SQARView.h -- Interface file for the SQARView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface SQARView:View {

	id		genEv;
	id		keyWindow;
	id		planeView;
	id		planeWindow;
	id		SQARWindow;
	id		sqarWindow;
	id		sqarView;

	id		bernZMatrix;
	id		bernOMatrix;
	id		bernView;
	id		golMatrix;
	id		mMent;
	id		nHood;
	id		nHoodValue;
	id		nMatrix;
	id		reStore;

	id		rulePanel;
	id		ruleNumber;
	id		ruleType;
	id		pSliders;
	id		pWindows;

	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		crossCursor;

}

- checkerBoard:sender;
- copyRule:sender;
- copyGolRule:sender;
- copySmEvol:sender;
- copySmMosaic:sender;
- drawBern:sender;
- drawGBern:sender;
- drawMosaic:sender;
- drawPlEvol:sender;
- drawSmEvol:sender;
- drawSmMosaic:sender;
- enterGolRule:sender;
- enterSemiBern:sender;
- loadSqar:sender;
- printBern:sender;
- printGBern:sender;
- printMosaic:sender;
- printPlEvol:sender;
- printSmEvol:sender;
- printSmMosaic:sender;
- randomLine:sender;
- readRule:sender;
- readNHood:sender;
- resetBern:sender;
- resetGolay:sender;
- resetNHood:sender;
- sCellLine:sender;
- showProbability:sender;
- uniformLine:sender;

- uprule:sender;
- lerule:sender;
- dorule:sender;
- rirule:sender;
- idrule:sender;
- mjrule:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end SQARView.h */
